#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "imapfilter.h"

/*
 * A malloc that checks the results and dies in case of error.
 */
void *xmalloc(size_t size)
{
    void *ptr;

    ptr = (void *) malloc(size);

    if (!ptr)
	fatal(ERROR_MEMORY_ALLOCATION,
	      "imapfilter: allocating memory; %s\n", strerror(errno));

    return ptr;
}


/*
 * A strdup that checks the results and dies in case of error.
 */
char *xstrdup(const char *s)
{
    char *cp;

    cp = strdup(s);

    if (!cp)
	fatal(ERROR_MEMORY_ALLOCATION,
	      "imapfilter: allocating memory; %s\n", strerror(errno));

    return cp;
}
